import { useEffect, useState } from 'react';
import { useAccount } from 'wagmi';
import useWebThreeAuth from './useWebThreeAuth';
export default function _useAccount() {
    var _a = useWebThreeAuth(), webThreeAuthSigner = _a.signer, infos = _a.infos;
    var _b = useAccount(), wagmiAddress = _b.address, wagmiConnector = _b.connector;
    var _c = useState(undefined), address = _c[0], setAddress = _c[1];
    var _d = useState(), connector = _d[0], setConnector = _d[1];
    useEffect(function () {
        if (webThreeAuthSigner) {
            webThreeAuthSigner.getAddress().then(function (_address) {
                setAddress(_address);
                setConnector('Torus');
            });
        }
        else if (wagmiAddress && wagmiConnector) {
            setAddress(wagmiAddress);
            setConnector(wagmiConnector.name);
        }
        else {
            setAddress(undefined);
            setConnector(undefined);
        }
    }, [webThreeAuthSigner, wagmiConnector, wagmiAddress]);
    return { address: address, connector: connector };
}
