var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Web3Auth } from '@web3auth/web3auth';
import { TorusWalletConnectorPlugin } from '@web3auth/torus-wallet-connector-plugin';
import { useEffect, useState } from 'react';
import { ADAPTER_EVENTS, } from '@web3auth/base';
import { useTheme } from '@mui/material';
import { ethers } from 'ethers';
var _initialized = false;
var _web3auth = null;
var _provider = null;
var _signer = null;
var _infos = null;
var _torusPlugin = null;
var _init = function (theme, setWeb3auth, setTorusPlugin) { return __awaiter(void 0, void 0, void 0, function () {
    var options;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (_initialized) {
                    return [2 /*return*/];
                }
                else {
                    _initialized = true;
                }
                _torusPlugin = new TorusWalletConnectorPlugin({
                    torusWalletOpts: {
                        buttonPosition: 'top-right',
                    },
                    walletInitOptions: {
                        whiteLabel: {
                            theme: {
                                isDark: false,
                                colors: { primary: theme.palette.primary.main },
                            },
                            logoDark: 'https://firebasestorage.googleapis.com/v0/b/nft-platform-445bc.appspot.com/o/landing%2Faccount-circle.svg?alt=media&token=5da0774f-976e-4ce6-9cc2-f86da31ec3a2',
                            logoLight: 'https://firebasestorage.googleapis.com/v0/b/nft-platform-445bc.appspot.com/o/landing%2Faccount-circle.svg?alt=media&token=5da0774f-976e-4ce6-9cc2-f86da31ec3a2',
                        },
                        showTorusButton: false,
                        useWalletConnect: true,
                        enableLogging: true,
                    },
                });
                options = {
                    clientId: window.chainConfig.testnet
                        ? 'BCaVu8YCoNOwnpsPNAWoMvEqpx5TzY9kEwrIahHkOQZO7A1NAXfzyfBVou54CNJMiluoHUBeP9-pqSYl9kFxqvM'
                        : 'BDuL11AtcP24oRMyF-NQL7DJKXciH_bXE08HtnOPSafrObQmDJFyDX1dvgyT5NZwUTZXUE7KrA2BFPvyKY1D3ME',
                    chainConfig: window.chainConfig,
                };
                _web3auth = new Web3Auth(options);
                return [4 /*yield*/, _web3auth.addPlugin(_torusPlugin)];
            case 1:
                _a.sent();
                return [4 /*yield*/, _web3auth.initModal()];
            case 2:
                _a.sent();
                setTorusPlugin(_torusPlugin);
                setWeb3auth(_web3auth);
                return [2 /*return*/];
        }
    });
}); };
export default function useWebThreeAuth() {
    var _this = this;
    var theme = useTheme();
    var _a = useState(_web3auth), web3auth = _a[0], setWeb3auth = _a[1];
    var _b = useState(false), pending = _b[0], setPending = _b[1];
    var _c = useState(_provider), provider = _c[0], setProvider = _c[1];
    var _d = useState(_signer), signer = _d[0], setSigner = _d[1];
    var _e = useState(_infos), infos = _e[0], setInfos = _e[1];
    var _f = useState(_torusPlugin), torusPlugin = _f[0], setTorusPlugin = _f[1];
    var onLogOut = function () {
        _torusPlugin === null || _torusPlugin === void 0 ? void 0 : _torusPlugin.torusWalletInstance.hideTorusButton();
        _provider = null;
        _signer = null;
        _infos = null;
        setInfos(null);
        setProvider(null);
        setSigner(null);
        setPending(false);
    };
    var connect = function () { return __awaiter(_this, void 0, void 0, function () {
        var provider_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!web3auth) {
                        return [2 /*return*/];
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, , 3, 4]);
                    setPending(true);
                    return [4 /*yield*/, web3auth.connect()];
                case 2:
                    provider_1 = _a.sent();
                    return [2 /*return*/, provider_1];
                case 3:
                    setPending(false);
                    return [7 /*endfinally*/];
                case 4: return [2 /*return*/];
            }
        });
    }); };
    var onConnect = function () { return __awaiter(_this, void 0, void 0, function () {
        var web3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // @ts-ignore
                    _provider = _torusPlugin === null || _torusPlugin === void 0 ? void 0 : _torusPlugin.torusWalletInstance.provider;
                    if (_provider) {
                        _torusPlugin === null || _torusPlugin === void 0 ? void 0 : _torusPlugin.torusWalletInstance.hideTorusButton();
                        setProvider(_provider);
                        web3 = new ethers.providers.Web3Provider(_provider);
                        _signer = web3.getSigner();
                        setSigner(_signer);
                    }
                    if (!web3auth) return [3 /*break*/, 2];
                    return [4 /*yield*/, web3auth.getUserInfo()];
                case 1:
                    _infos = _a.sent();
                    setInfos(_infos);
                    _a.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); };
    useEffect(function () {
        _init(theme, setWeb3auth, setTorusPlugin);
    }, []);
    useEffect(function () {
        if (!web3auth) {
            return;
        }
        web3auth.on(ADAPTER_EVENTS.CONNECTED, function (data) {
            onConnect();
        });
        // web3auth.on(ADAPTER_EVENTS.CONNECTING, () => {
        //     console.log('connecting')
        //   })
        web3auth.on(ADAPTER_EVENTS.DISCONNECTED, function () {
            onLogOut();
        });
        //   web3auth.on(ADAPTER_EVENTS.ERRORED, (error) => {
        //     console.log('error', error)
        //   })
        //   web3auth.on(ADAPTER_EVENTS.ERRORED, (error) => {
        //     console.log('error', error)
        //   })
    }, [web3auth]);
    return { web3auth: web3auth, provider: provider, signer: signer, pending: pending, infos: infos, torusPlugin: torusPlugin, connect: connect };
}
